#pragma once

#include <vector>
#include <utility>
#include <algorithm>

#include "edge.cpp"

std::vector<std::vector<int>> warshall_floyd(std::vector<Edge> edges, int n){
    std::vector<std::vector<int>> dist(n, std::vector<int>(n, 1e9));

    for(auto e : edges){
        dist[e.from][e.to] = 1;
        dist[e.to][e.from] = 1;
    }

    for(int i = 0;i < n;i++){
        dist[i][i] = 0;
    }

    for(int k = 0;k < n;k++){
        for(int i = 0;i < n;i++){
            for(int j = 0;j < n;j++){
                dist[i][j] = std::min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    return dist;
}